;===========================================================================================
; directxproc.asm    AsmGges France                http://www.chez.com/asmgges/index.htm
;===========================================================================================

;===========================================================================================
; Cration d'une surface
;-------------------------------------------------------------------------------------------
; @AdrSurface = adresse de la variable qui va contenir l'adresse de la surface cre
; @LSurface   = largeur de la surface en pixels
; @HSurface   = hauteur de la surface en pixels
;===========================================================================================
proc CreateSurf @AdrSurface, @LSurface, @HSurface

    stdcall ZeroMemory,ddsd,sizeof.DDSURFACEDESC
    mov [ddsd.dwSize],sizeof.DDSURFACEDESC
    mov [ddsd.dwFlags],DDSD_CAPS+DDSD_WIDTH+DDSD_HEIGHT
    mov [ddsd.ddsCaps.dwCaps],DDSCAPS_OFFSCREENPLAIN
    mov eax,[@LSurface]
    mov [ddsd.dwWidth],eax
    mov eax,[@HSurface]
    mov [ddsd.dwHeight],eax
    ddcall DD_CreateSurface,[DDraw],ddsd,[@AdrSurface],0

    ret
endp
;===========================================================================================
; Charge un fichier bmp dans une surface
;-------------------------------------------------------------------------------------------
; @AdrBmpFile = adresse du chemin du fichier .bmp
; @Surface    = [Nom] surface ou sera copi le bmp
;===========================================================================================
proc LoadBmp @AdrBmpFile, @Surface

    invoke LoadImage,0,[@AdrBmpFile],IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION+LR_LOADFROMFILE
    or eax,eax
    jz .BmpError

    mov [hBitmap],eax

    invoke GetObject,[hBitmap],24,bitmap2

    invoke CreateCompatibleDC,0
    mov [hdcImage],eax

    invoke SelectObject,[hdcImage],[hBitmap]
    mov [hbmOld],eax

    ddcall DDS_GetDC,[@Surface],hdc
    .if eax = 0
        invoke BitBlt,[hdc],0,0,[bitmap2.bmWidth],[bitmap2.bmHeight],[hdcImage],0,0,SRCCOPY
        ddcall DDS_ReleaseDC,[@Surface],[hdc]
    .endif

    invoke SelectObject,[hdcImage],[hbmOld]
    invoke DeleteObject,[hBitmap]
    invoke DeleteDC,[hdcImage]

    ddcall DDS_SetColorKey,[@Surface],DDCKEY_SRCBLT,ddcolorkey
    or eax,eax
    jnz .BmpError

    ret

.BmpError:
    mov eax,1

    ret
endp
;===========================================================================================
; Remplir une surface avec une couleur
;-------------------------------------------------------------------------------------------
; @NumSurf = [Nom] Surface  remplir
; @Color   = couleur de remplissage format RGB 000000h
;===========================================================================================
proc FillSurface @NumSurf, @Color

    call ZeroMemory,ddbltfx,sizeof.DDBLTFX
    mov [ddbltfx.dwSize],sizeof.DDBLTFX
    mov eax,[@Color]
    mov [ddbltfx.dwFillColor],eax
    ddcall DDS_Blt,[@NumSurf],0,0,0,DDBLT_COLORFILL+DDBLT_WAIT,ddbltfx
    
    ret
endp
;===========================================================================================
; Flip surface Back => surface Primary (Window Mode)
;===========================================================================================
FlipBackWinMode:
    invoke GetWindowRect,[hWin],rect2

    mov [rect1.left],0
    mov [rect1.top],0
    mov [rect1.right],WSCREEN
    mov [rect1.bottom],HSCREEN

    mov eax,[rect2.left]
    add eax,WSCREEN
    mov [rect2.right],eax

    mov eax,[rect2.top]
    add eax,[HBarTitle]
    mov [rect2.top],eax

    add eax,HSCREEN
    mov [rect2.bottom],eax
    ddcall DDS_Blt,[Primary],rect2,[Back],rect1,DDBLT_WAIT,0

    ret
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================